﻿<?php
///////////////////////////////////////////////////////////////////////////

	const SERVICE_FAMILY = 14;
	const AUTH_SHARE =
	'http://%s/api/json/getcode.php?box_cpu=%s&service_id=%s';
	const CREATE_SESSION =
	'http://%s/api/json/create_session.php?box_cpu=%s&service_id=%s';
class KTV
{
    
    public static $AUTH_SHARE  = 'dune.iptvsys.com';
}


class RodnoeApi
{
	private $sid = null;
	private $is_logged = null;
	

	public function is_logged_in()
    	{ return $this->is_logged; }
        
         public function fetch_document($url)
    {
        $doc = HD::http_get_document($url, $this->http_opts);

        // assert($doc != null).

        return $doc;
    }
    
        public function api_call($url, $silent=true)
    {
        for (;;)
        {
            $str = $this->fetch_document($url);

            if (!$silent)
                echo("Document:\n$str\n");

            $reply = json_decode($str);
            if ($reply === null)
                throw new Exception('Invalid data received from server');

            if (isset($reply->error))
            {
                $ecode = intval($reply->error->code);

                if ($ecode === ECODE_QUERY_LIMIT_EXCEEDED)
                {
                    hd_print('API: query limit exceeded');
                    continue;
                }

                hd_print("API error: URL '$url' " .
                    "returned error with code=$ecode, msg=" .
                    $reply->error->message . '.');

                throw new RodnoeException(
                    $reply->error->message, $ecode);
            }

            break;
        }

        return $reply;
    }
	public function api_getcode(&$plugin_cookies)
    { 
	
    	$cpu = trim(
    			system(
    					"cat /fconfig/dune_license.dlf | cut -d' ' -f3 -s"
    			)
    	);
    	hd_print($cpu);
    	try
    	{
    		$doc = $this->api_call(
    				sprintf(
    						AUTH_SHARE, KTV::$AUTH_SHARE,
    						$cpu,
    						SERVICE_FAMILY),
    				false);
		$this->api_call(
    				sprintf(
    						CREATE_SESSION, KTV::$AUTH_SHARE,
    						$cpu,
    						SERVICE_FAMILY),
    				false);
    	}
    	catch (Exception $e)
    	{
            hd_print("Error no code=>".$e);
            throw $this->dune_api_exception($e, 'Login failed.', false);
    	}
    	hd_print('GET CODE: login=>' . $doc->response->login . "\n password => " . $doc->response->password);
    	$plugin_cookies->login = $doc->response->login;
    	$plugin_cookies->pass = $doc->response->password;
        hd_print('login=>'.$plugin_cookies->login."\n password =>".$plugin_cookies->pass);
    	 
    }
///////////////////////////////////////////////////////////////////////////
	public function login_rodnoe($login,$pass)
		{
						
			$md5pass = $this->get_md5_pass($login,$pass);
			$doc = "http://file-teleport.com/iptv/api/v1/xml/login?login=$login&pass=$md5pass";
			hd_print("--->>> login: $doc");
			$xml = $this->xml_fetch($doc);
			$sid = $xml->sid;
			hd_print("--->>> sid: $sid");
			$this->sid = $sid;
			$this->is_logged = true;
			hd_print("--->>> is_logged: $this->is_logged");
			return $sid;     

		}
///////////////////////////////////////////////////////////////////////////
	public function logout_rodnoe($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/logout?sid=$sid";
			hd_print("--->>> logout: $doc");
			$xml = $this->xml_fetch($doc);
			$message = $xml->message;
			hd_print("--->>> logout message: $message");	
		}
///////////////////////////////////////////////////////////////////////////
	public function noop_rodnoe($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/noop?sid=$sid";
			hd_print("--->>> is login in server: $doc");
			$xml = $this->xml_fetch($doc);
			$message = strval($xml->message);
			hd_print("--->>> is login in server: $message");
			return $message;				
		}
///////////////////////////////////////////////////////////////////////////
	public function load_groups()
		{
        		$doc = "http://file2.npage.de/012382/37/html/groups3.xml";

        		hd_print("--->>> get_list_group: $doc");
			$xml = $this->xml_fetch($doc);
			return $xml;	
		}
///////////////////////////////////////////////////////////////////////////
	public function load_tv_list($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_channels_tv?sid=$sid";
			hd_print("--->>> get_list_tv: $doc");
			$xml = $this->xml_fetch($doc);
			return $xml;	
		}
///////////////////////////////////////////////////////////////////////////
	public function load_radio_list($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_list_radio?sid=$sid";
			hd_print("--->>> get_list_radio: $doc");
			$xml = $this->xml_fetch($doc);
			return $xml;
		}
///////////////////////////////////////////////////////////////////////////
	public function get_url_tv($cid,$archive,$protect,$sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_url_tv?sid=$sid&cid=$cid";
			if (isset($protect) && $protect !== '')
				{
					$doc .= "&protect_code=$protect";
					hd_print("---> protected::$protect");
				}
			if (intval($archive) > 0)
				{
					$doc .= "&uts=$archive";
					hd_print("---> arch::$archive");
				}

			hd_print("---> get_url_tv: $doc");
			

        		$xml = $this->xml_fetch($doc);
			return $xml;			
			
		}
///////////////////////////////////////////////////////////////////////////
	public function get_url_radio($cid,$sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_url_radio?sid=$sid&cid=$cid";
			hd_print("--->>> get_url_radio: $doc");
			$xml = $this->xml_fetch($doc);
			return $xml;				
		}
///////////////////////////////////////////////////////////////////////////
	public function get_groups_tv($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_groups_tv?sid=$sid";
			hd_print("--->>> get_groups_tv: $doc");
			$xml = $this->xml_fetch($doc);
			return $xml;			
		}

///////////////////////////////////////////////////////////////////////////
	public function get_rodnoe_epg($day_start,$channel_id,$sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_epg?sid=$sid&cid=$channel_id&from_uts=$day_start&hours=24";
			hd_print("--->>> epg: $doc");

			$xml = $this->xml_fetch($doc);
        		if ($xml->channels->getName() !== 'channels')
        		{
            			hd_print("Error: unexpected node '" . $xml->channels->getName() . "'. Expected: 'channels'");
            			throw new Exception('Invalid XML document');
        		}
			return $xml;

		}
///////////////////////////////////////////////////////////////////////////
	public function get_account_info($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_account_info?sid=$sid";
			hd_print("--->>> get_account_info: $doc");
			$xml = $this->xml_fetch($doc);
						
		}
///////////////////////////////////////////////////////////////////////////
	public function get_settings($sid)
		{
			$doc = "http://file-teleport.com/iptv/api/v1/xml/get_settings?sid=$sid";
			hd_print("--->>> get_settings_info: $doc");
			$xml = $this->xml_fetch($doc);			
		}
///////////////////////////////////////////////////////////////////////////
	public function set_settings($sid)//переделать
		{
			$doc = HD::http_get_document("http://file-teleport.com/iptv/api/v1/xml/get_settings?sid=$sid");
			hd_print("--->>> get_account_info: $doc");
			$xml = simplexml_load_string($doc);

        		if ($xml === false)
        		{
         		   hd_print("Error: can not parse XML document.");
         		   hd_print("XML-text: $doc.");
         		   throw new Exception('Illegal XML document');
        		}

        		if ($xml->getName() !== 'response')
        		{
        		    hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
        		    throw new Exception('Invalid XML document');
        		}
			return $xml;			
		}
///////////////////////////////////////////////////////////////////////////
	private function get_md5_pass($login,$pass)
		{
			$md5sum = md5(md5($login).md5($pass));
			return $md5sum;
		}
///////////////////////////////////////////////////////////////////////////
	public function check_for_arch()
		{
			$plugin_dir = DuneSystem::$properties['install_dir_path'];
			if (!file_exists('/tmp/arch/msdl'))
				{
					system("mkdir /tmp/arch",$return_var);
					system("cp $plugin_dir/msdl /tmp/arch/msdl",$return_var);
					system("chmod +x /tmp/arch/msdl", $return_var);
				}
			if (!file_exists('/tmp/arch/cgi-bin/arch'))
				{
					system("mkdir /tmp/arch/cgi-bin",$return_var);
					system("cp $plugin_dir/arch /tmp/arch/cgi-bin/arch",$return_var);
					system("chmod +x /tmp/arch/cgi-bin/arch", $return_var);
				}
			$hh = system('ps | grep httpd | grep -c /tmp/arch',$return_var);
			hd_print("var httpd:  $hh");
			if ( $hh <= 1)
				{
					system("httpd -h /tmp/arch -p 1000",$return_var);
				}
			return true;
			
		}
///////////////////////////////////////////////////////////////////////////

	public function xml_fetch($url)
		{
			$doc = HD::http_get_document($url);
			#hd_print("--->>> get_xml: $doc");
			$xml = simplexml_load_string($doc);
       	 		if (is_null($doc))
            			throw new Exception("Can not fetch $doc");
        		if ($xml === false)
        		{
         		   hd_print("Error: can not parse XML document.");
         		   hd_print("XML-text: $doc.");
         		   throw new Exception('Illegal XML document');
        		}

        		if ($xml->getName() !== 'response')
        		{
        		    hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
			    hd_print("XML-text: $doc.");
        		    throw new Exception('Invalid XML document');
        		}
			return $xml;			
		}
///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    public function dune_api_exception($e, $def_caption, $is_playback)
    {
        $is_oft_error = ($e instanceof RodnoeException);
        hd_print('is_otf_error =>'.$is_oft_error);
        if (!$is_oft_error)
        {
            hd_print('General exception: ' . $e);
            $title = !$is_playback ? 'Error' :
                'Failed to connect to Internet.';
            $text_lines = $is_playback ? array() :
                array(
                 'Failed to connect to Internet.',
                 'Please check Internet connection.'
                );
            return new DuneException(
                $def_caption, -1,
                ActionFactory::show_error(false, $title, $text_lines));
        }
        hd_print(' API exception: ' .
            'code=' . $e->getCode() . ', message=' . $e->getMessage());

        $service_name = 'Russian Family';
	$service_phone_number = '718-713-8338';
	$service_support_email = 'support@russiantvcompany.com.';
	$service_common_message = ' please call '.$service_phone_number.' or email to '.$service_support_email;        
	$ecode = $e->getCode();
        hd_print('ecode'.$ecode);
        $fatal = $ecode == 5 || $ecode == 6 ||
            $ecode == 11 || $ecode == 12 || $ecode == 13;

        if ($fatal)
            $this->logout();

        if ($ecode == 2 || $ecode == 4)
        {
            $this->login_incorrect = true;

            $title = !$is_playback ? $service_name : 'To activate service'.$service_common_message;
            $text_lines = $is_playback ? array() : array('To activate service'.$service_common_message);
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }

        if ($ecode == 3)
        {
            $title = !$is_playback ? $service_name :'Access denied for 10 minutes.';
            $text_lines = $is_playback ? array() : array('Access denied for 10 minutes.');
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }

        if ($ecode == 11)
        {
            $title = !$is_playback ? $service_name : 'Service is being used on another device.';
            $text_lines = $is_playback ? array() : array('Service is being used on another device.');
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }

        if ($ecode == 12)
        {
            $title = !$is_playback ? $service_name : 'Service is being used on another device.';
            $text_lines = $is_playback ? array() : array('Service is being used on another device');
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }


        if ($ecode == 19)
        {
            $title = !$is_playback ? $service_name : 'To activate service'.$service_common_message;
            $text_lines = $is_playback ? array() : array('To activate service'.$service_common_message);
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }
	if ($ecode == 17)
        {
            $title = !$is_playback ? $service_name : 'To activate service'.$service_common_message;
            $text_lines = $is_playback ? array() : array('To activate service'.$service_common_message);
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }
	if ($ecode == 102)
        {
            $title = !$is_playback ? $service_name : 'To activate service'.$service_common_message;
            $text_lines = $is_playback ? array() : array('To activate service'.$service_common_message);
            hd_print('def_cap=>'.$def_caption."\n ecode=>".$ecode."\n title=>".$title."\n text_ines".$text_lines);
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
            $this->logout_rodnoe();
        }
	if ($ecode == 105)
        {
            $title = !$is_playback ? $service_name : $e->getMessage();
            $text_lines = $is_playback ? array() : array($e->getMessage(),'To register'.$service_common_message);
            return new DuneException(
                $def_caption, $ecode,
                ActionFactory::show_error($fatal, $title, $text_lines));
        }

        $title = !$is_playback ? $service_name : $e->getMessage();
        $text_lines = $is_playback ? array() : array($e->getMessage());               
        return new DuneException(
            $def_caption, $ecode,
            ActionFactory::show_error($fatal, $title, $text_lines));
    }

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

}
///////////////////////////////////////////////////////////////////////////
?>
